%define target avr

Name:           %{target}-binutils
Version:        2.24
Release:        3%{?dist}
Epoch:          1
Summary:        Cross Compiling GNU binutils targeted at %{target}
Group:          Development/Tools
License:        GPLv2+
URL:            http://www.gnu.org/software/binutils/
Source0:        ftp://ftp.gnu.org/pub/gnu/binutils/binutils-%{version}.tar.bz2
Source1:        README.fedora
#add widespread options to avr-size: --format=avr -mcu=XX
Patch1: http://distribute.atmel.no/tools/opensource/avr-gcc/binutils-2.20.1/30-binutils-2.20.1-avr-size.patch
Patch2: binutils-2.24-cve_2014_8501.patch
Patch3: binutils-2.24-cve_2014_8502pre.patch
Patch4: binutils-2.24-cve_2014_8502a.patch
Patch5: binutils-2.24-cve_2014_8503.patch
Patch6: binutils-2.24-cve_2014_8504.patch
Patch7: binutils-2.24-dirtravel.patch
Patch8: binutils-2.24-cve_2014_8738.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-%(%{__id_u} -n)
BuildRequires:  gawk texinfo
#for autoreconf:
BuildRequires:  gettext-devel autoconf automake
Provides: bundled(libiberty)

%description
This is a Cross Compiling version of GNU binutils, which can be used to
assemble and link binaries for the %{target} platform, instead of for the
native %{_arch} platform.


%prep
%setup -q -c
pushd binutils-%{version}
%patch1 -p0 -b .avr-size
%patch2 -p1 -b .cve_2014_8501
%patch3 -p1 -b .cve_2014_8502pre
%patch4 -p1 -b .cve_2014_8502
%patch5 -p1 -b .cve_2014_8503
%patch6 -p2 -b .cve_2014_8504
%patch7 -p1 -b .dirtravel
%patch8 -p1 -b .cve_2014_8738

popd 
cp %{SOURCE1} .


%build
mkdir -p build
pushd build
CFLAGS="$RPM_OPT_FLAGS" ../binutils-%{version}/configure --prefix=%{_prefix} \
  --libdir=%{_libdir} --mandir=%{_mandir} --infodir=%{_infodir} \
  --target=%{target} --disable-werror --disable-nls
make %{?_smp_mflags}
popd build


%install
rm -rf $RPM_BUILD_ROOT
pushd build
make install DESTDIR=$RPM_BUILD_ROOT
popd build
# these are for win targets only
rm $RPM_BUILD_ROOT%{_mandir}/man1/%{target}-{dlltool,nlmconv,windres}.1
# we don't want these as we are a cross version
rm -r $RPM_BUILD_ROOT%{_infodir}
rm    $RPM_BUILD_ROOT%{_libdir}/libiberty.a ||:


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc binutils-%{version}/COPYING binutils-%{version}/COPYING.LIB
%doc binutils-%{version}/README README.fedora
%{_prefix}/%{target}
%{_bindir}/%{target}-*
%{_mandir}/man1/%{target}-*.1.gz


%changelog
* Thu Nov 13 2014 Michal Hlavinka <mhlavink@redhat.com> - 1:2.24-3
- fix CVE-2014-8738: out of bounds memory write

* Wed Nov 12 2014 Michal Hlavinka <mhlavink@redhat.com> - 1:2.24-2
- fix directory traversal vulnerability (#1162657)
- fix CVE-2014-8501: out-of-bounds write when parsing specially crafted PE executable
- fix CVE-2014-8502: heap overflow in objdump
- fix CVE-2014-8503: stack overflow in objdump when parsing specially crafted ihex file
- fix CVE-2014-8504: stack overflow in the SREC parser

* Wed Aug 13 2014 Michal Hlavinka <mhlavink@redhat.com> - 1:2.24-1
- updated to 2.24

* Mon Feb 03 2014 Michal Hlavinka <mhlavink@redhat.com> - 1:2.23.2-4
- avr-binutils may be affected by libiberty CVE (#1059362)

* Tue Aug 13 2013 Michal Hlavinka <mhlavink@redhat.com> - 1:2.23.2-3
- fix tex again

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:2.23.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Mon Jun 24 2013 Michal Hlavinka <mhlavink@redhat.com> - 1:2.23.2-1
- updated to 2.23.2

* Tue Jun 18 2013 Jaromir Capik <jcapik@redhat.com> - 1:2.23.1-4
- autoreconf -vif doesn't work -> patching for aarch64 support (#925061)

* Fri Apr 19 2013 Michal Hlavinka <mhlavink@redhat.com> - 1:2.23.1-3
- fix aarch64 support (#925061)

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:2.23.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Nov 15 2012 Michal Hlavinka <mhlavink@redhat.com> - 1:2.23.1-1
- updated to 2.23.1
- added new option --format=avr to avr-size for compatibility reasons 
  with other avr toolchains

* Mon Oct 15 2012 Jon Ciesla <limburgher@gmail.com> - 1:2.20-5
- Provides: bundled(libiberty)

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:2.20-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jan 12 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:2.20-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Fri Nov 11 2011 Thibault North <tnorth@fedoraproject.org> - 1:2.20-2
- Downgrade to 2.20 because of BZ#688645

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.21-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Dec 19 2010 Thibault North <tnorth@fedoraproject.org> - 2.21-1
- New upstream release 2.21

* Fri Nov 20 2009 Thibault North <tnorth AT fedoraproject DOT org> - 2.20-1
- New upstream release

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.18-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat Feb 28 2009 Ralf Corsépius <corsepiu@fedoraproject.org> - 2.18-4
- Rebase patch-coff-avr.patch (Fix F11 rebuild breakdown).

* Mon Feb 23 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.18-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 2.18-2
- Autorebuild for GCC 4.3

* Thu Jan 24 2008 John Voltz <ninevoltz@metalink.net> 2.18-1
- Bump to binutils 2.18 and add coff-avr patch for VMLAB (on Wine)

* Sun Dec  2 2007 Hans de Goede <j.w.r.degoede@hhs.nl> 2.17-5
- Fix building with texinfo version > 4.9 (4.11 for example)

* Wed Aug 22 2007 Hans de Goede <j.w.r.degoede@hhs.nl> 2.17-4
- Update License tag for new Licensing Guidelines compliance
- Fix building with new glibc open checking

* Sat Apr  7 2007 Hans de Goede <j.w.r.degoede@hhs.nl> 2.17-3
- Use mkdir -p instead of mkdir, to fix rpmbuild --short-circuit (bz 234750)

* Fri Apr  6 2007 Hans de Goede <j.w.r.degoede@hhs.nl> 2.17-2
- Several specfile improvements / fixes (bz 234750)

* Sun Apr  1 2007 Hans de Goede <j.w.r.degoede@hhs.nl> 2.17-1
- Revert to GNU 2.17 release as using GNU releases are better for non linux
  targets
- Add --disable-nls, to disable translations, so that we don't use the native
  PO files, as using the PO files of the (different version) native binutils,
  can lead to all kinda problems when translating formatstrings.
- Don't use %%configure but DIY, to avoid unwanted side effects of %%configure

* Sun Apr  1 2007 Hans de Goede <j.w.r.degoede@hhs.nl> 2.17.50.0.12-1
- Bump to 2.17.50.0.12, to sync with rawhide / Fedora 7
- "Dynamicly Generate" README.fedora so that macros can be used

* Thu Mar 29 2007 Hans de Goede <j.w.r.degoede@hhs.nl> 2.17.50.0.9-1
- Bump to 2.17.50.0.9
- Use %%configure instead of ./configure
- Various fixups

* Wed Mar 28 2007 Koos Termeulen koostermeulen@gmail.com 2.17-1
- New version and some changes after unofficial review by Hans de Goede

* Wed Mar 21 2007 Koos Termeulen koostermeulen@gmail.com 2.16.1-1
- Initial release
